<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The soil data is used to compute the nutrients provided by the soil: it is prefilled with the average data from your area provided by REQUASUD.</translate>
          </q-banner>

          <q-card-section>
            <div>
              <div class="text-body2 text-grey-8 q-mb-xs">
                <translate>Did you do a soil analysis for this plot?</translate>
              </div>
              <q-btn-toggle
                v-model="storeSoilSampleExists"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>

            <template v-if="isSoilSampleExistsDefined">
              <DateSelectorInput
                v-if="storeSoilSampleExists"
                v-model="storeSoilSampleDate"
                :rules="[ val => val !== null && val !== undefined || $gettext('Select a date') ]"
                :label="$gettext('Soil analysis date')"
                class="q-mt-md"
              />

              <div class="row q-gutter-x-md q-mt-md">
                <q-input
                  v-model.number="storeSoilNNO3Profile"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('NNO3 profile')"
                  :suffix="$gettext('kg N/ha')"
                  :min="0"
                  class="col"
                />
                <q-input
                  v-model.number="storeSoilNNH4Profile"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('NNH4 profile')"
                  :suffix="$gettext('kg N/ha')"
                  :min="0"
                  class="col"
                />
              </div>

              <q-input
                v-model.number="storeSoilResidualN"
                step="any"
                filled
                type="number"
                :label="$gettext('Residual N')"
                :suffix="$gettext('kg N/ha')"
                :min="0"
                class="q-mt-md"
              />

              <q-select
                v-model="storeSoilOrganicMeasureType"
                :label="$gettext('Organic matter measure')"
                :options="organicMeasureTypeOptions"
                filled
                class="q-mt-md"
              />

              <q-input
                v-if="showOrganicMatterContent"
                v-model.number="storeSoilOrganicMatterContent"
                step="any"
                filled
                type="number"
                :label="$gettext('Organic matter content')"
                :suffix="$gettext('%')"
                :min="0"
                class="q-mt-md"
              />

              <q-input
                v-if="showCarbonContent"
                v-model.number="storeSoilCarbonContent"
                step="any"
                filled
                type="number"
                :label="$gettext('Carbon content')"
                :suffix="$gettext('%')"
                :min="0"
                class="q-mt-md"
              />

              <q-input
                v-if="showHumusNContent"
                v-model.number="storeSoilNHumus"
                step="any"
                filled
                type="number"
                :label="$gettext('Humus N content')"
                :suffix="$gettext('g/kg or ‰')"
                :min="0"
                class="q-mt-md"
              />

              <div class="row q-gutter-x-md q-mt-md">
                <q-input
                  v-model.number="storeSoilClayContent"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Clay content')"
                  :suffix="$gettext('‰')"
                  :min="0"
                  class="col"
                />
                <q-input
                  v-model.number="storeSoilCalciumContent"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Calcium content')"
                  :suffix="$gettext('‰')"
                  :min="0"
                  class="col"
                />
              </div>

              <q-expansion-item
                v-model="storeSoilAdvanced"
                :label="$gettext('Advanced parameters')"
                header-class="text-subtitle2 text-grey-8 q-px-none"
                class="q-mt-md"
              >
                <div>
                  <div class="text-body2 text-grey-8 q-mb-xs">
                    <translate>Are the soil conditions unfavorable?</translate>
                  </div>
                  <q-btn-toggle
                    v-model="storeSoilConditionsAreUnfavorable"
                    :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                    toggle-color="primary"
                  />
                </div>

                <q-input
                  v-model.number="storeSoilStonyContent"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Stony content')"
                  :suffix="$gettext('%')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilAverageAirTemperature"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Average air temperature')"
                  :suffix="$gettext('°C')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilDensity"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Soil density')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilDepth"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Topsoil depth')"
                  :suffix="$gettext('cm')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilConversionFactor"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Conversion factor')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilKm"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Mineralization coefficient')"
                  :min="0"
                  class="q-mt-md"
                />

                <q-input
                  v-model.number="storeSoilMineralizationPotential"
                  step="any"
                  filled
                  type="number"
                  :label="$gettext('Mineralization potential') + $gettext(' (optional)')"
                  :min="0"
                  class="q-mt-md"
                />
              </q-expansion-item>
            </template>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import DateSelectorInput from 'src/components/form/DateSelectorInput'
import queryRequafertiSoil from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiSoil'
import querySoilDerivedObjectsByPlotId from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/querySoilDerivedObjectsByPlotId'

const SOIL_DERIVED_PROPERTIES = [
  'couche_arable',
  'argile',
  'calcaire',
  'carbone',
  'nnh4_profil',
  'nno3_profil',
  'densite',
  'cailloux',
  'rapport_c_n',
  'mo',
  'nhumus'
]

export default {
  name: 'RequafertiSoilPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    DateSelectorInput
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      requafertiSoil: null,
      plotSoilDerivedProperties: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Soil')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storeSoilSampleExists) &&
        (!this.storeSoilSampleExists || this.isParameterSet(this.storeSoilSampleDate)) &&
        this.isParameterSet(this.storeSoilConditionsAreUnfavorable) &&
        this.isParameterSet(this.storeSoilNNO3Profile) &&
        this.isParameterSet(this.storeSoilClayContent) &&
        this.isParameterSet(this.storeSoilOrganicMeasureType) &&
        (this.isParameterSet(this.storeSoilCarbonContent) || this.isParameterSet(this.storeSoilOrganicMatterContent) || this.isParameterSet(this.storeSoilNHumus))
    },
    plotId () {
      return this.$store.state.fertilizationPlan.target.id
    },
    plotCenterGeometry () {
      const coordinates = this.$store.state.fertilizationPlan.target.centroid?.coordinates
      return { type: 'Point', coordinates }
    },
    organicMeasureTypeOptions () {
      return [{
        value: 'organicMatterContent',
        label: this.$gettext('Organic matter content'),
        field: 'storeSoilOrganicMatterContent'
      }, {
        value: 'carbonContent',
        label: this.$gettext('Carbon'),
        field: 'storeSoilCarbonContent'
      }, {
        value: 'humusNContent',
        label: this.$gettext('Humus'),
        field: 'storeSoilNHumus'
      }]
    },
    showOrganicMatterContent () {
      return this.storeSoilOrganicMeasureType?.value === 'organicMatterContent'
    },
    showCarbonContent () {
      return this.storeSoilOrganicMeasureType?.value === 'carbonContent'
    },
    showHumusNContent () {
      return this.storeSoilOrganicMeasureType?.value === 'humusNContent'
    },
    storeSoilSampleExists: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilSampleExists
      },
      set (v) {
        this.updateParameter('soilSampleExists', v)
      }
    },
    storeSoilSampleDate: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilSampleDate
      },
      set (v) {
        this.updateParameter('soilSampleDate', v)
      }
    },
    storeSoilConditionsAreUnfavorable: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilConditionsAreUnfavorable
      },
      set (v) {
        this.updateParameter('soilConditionsAreUnfavorable', v)
      }
    },
    storeSoilNNO3Profile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilNNO3Profile
      },
      set (v) {
        this.updateParameter('soilNNO3Profile', v)
      }
    },
    storeSoilNNH4Profile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilNNH4Profile
      },
      set (v) {
        this.updateParameter('soilNNH4Profile', v)
      }
    },
    storeSoilResidualN: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilResidualN
      },
      set (v) {
        this.updateParameter('soilResidualN', v)
      }
    },
    storeSoilStonyContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilStonyContent
      },
      set (v) {
        this.updateParameter('soilStonyContent', v)
      }
    },
    storeSoilDensity: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilDensity
      },
      set (v) {
        this.updateParameter('soilDensity', v)
      }
    },
    storeSoilDepth: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilDepth
      },
      set (v) {
        this.updateParameter('soilDepth', v)
      }
    },
    storeSoilAverageAirTemperature: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilAverageAirTemperature
      },
      set (v) {
        this.updateParameter('soilAverageAirTemperature', v)
      }
    },
    storeSoilClayContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilClayContent
      },
      set (v) {
        this.updateParameter('soilClayContent', v)
      }
    },
    storeSoilCalciumContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilCalciumContent
      },
      set (v) {
        this.updateParameter('soilCalciumContent', v)
      }
    },
    storeSoilOrganicMeasureType: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilOrganicMeasureType
      },
      set (v) {
        this.updateParameter('soilOrganicMeasureType', v)
      }
    },
    storeSoilOrganicMatterContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilOrganicMatterContent
      },
      set (v) {
        this.updateParameter('soilOrganicMatterContent', v)
      }
    },
    storeSoilCarbonContent: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilCarbonContent
      },
      set (v) {
        this.updateParameter('soilCarbonContent', v)
      }
    },
    storeSoilNHumus: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilNHumus
      },
      set (v) {
        this.updateParameter('soilNHumus', v)
      }
    },
    storeSoilConversionFactor: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilConversionFactor
      },
      set (v) {
        this.updateParameter('soilConversionFactor', v)
      }
    },
    storeSoilKm: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilKm
      },
      set (v) {
        this.updateParameter('soilKm', v)
      }
    },
    storeSoilMineralizationPotential: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilMineralizationPotential
      },
      set (v) {
        this.updateParameter('soilMineralizationPotential', v)
      }
    },
    storeSoilAdvanced: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.soilAdvanced
      },
      set (v) {
        this.updateParameter('soilAdvanced', v)
      }
    },
    isSoilSampleExistsDefined () {
      return this.isParameterSet(this.storeSoilSampleExists)
    },
    isSoilSampleDateDefined () {
      return this.isParameterSet(this.storeSoilSampleDate)
    }
  },
  async mounted () {
    if (!this.isParameterSet(this.storeSoilAdvanced)) {
      this.storeSoilAdvanced = false
    }

    // Load data from cache (or online if not in cache): soil properties must be loaded before soil params
    await this.loadSoilProperties('cache-first')
    await this.loadSoilParams('cache-first')

    // prefill soil values using historical regional data when there is no soil sample
    if (!this.isParameterSet(this.storeSoilConditionsAreUnfavorable)) {
      this.storeSoilConditionsAreUnfavorable = false
    }
    if (!this.isParameterSet(this.storeSoilNNO3Profile)) {
      this.storeSoilNNO3Profile = this.round(this.requafertiSoil.nno3_profil, 1)
    }
    if (!this.isParameterSet(this.storeSoilNNH4Profile)) {
      this.storeSoilNNH4Profile = this.round(this.requafertiSoil.nnh4_profil, 1)
    }
    if (!this.isParameterSet(this.storeSoilResidualN)) {
      this.storeSoilResidualN = this.round(this.requafertiSoil.reliquat_n, 1)
    }
    if (!this.isParameterSet(this.storeSoilStonyContent)) {
      this.storeSoilStonyContent = this.round(this.requafertiSoil.cailloux, 2)
    }
    if (!this.isParameterSet(this.storeSoilDensity)) {
      this.storeSoilDensity = this.round(this.requafertiSoil.densite, 2)
    }
    if (!this.isParameterSet(this.storeSoilDepth)) {
      this.storeSoilDepth = this.round(this.requafertiSoil.couche_arable, 0)
    }
    if (!this.isParameterSet(this.storeSoilAverageAirTemperature)) {
      this.storeSoilAverageAirTemperature = this.round(this.requafertiSoil.temp_air, 1)
    }
    if (!this.isParameterSet(this.storeSoilClayContent)) {
      this.storeSoilClayContent = this.round(this.requafertiSoil.argile, 0)
    }
    if (!this.isParameterSet(this.storeSoilCalciumContent)) {
      this.storeSoilCalciumContent = this.round(this.requafertiSoil.calcaire, 0)
    }
    if (!this.isParameterSet(this.storeSoilOrganicMeasureType)) {
      this.storeSoilOrganicMeasureType = this.organicMeasureTypeOptions?.[0]
    }
    if (!this.isParameterSet(this.storeSoilOrganicMatterContent)) {
      this.storeSoilOrganicMatterContent = this.round(this.requafertiSoil.mo, 1)
    }
    if (!this.isParameterSet(this.storeSoilCarbonContent)) {
      this.storeSoilCarbonContent = this.round(this.requafertiSoil.carbone, 1)
    }
    if (!this.isParameterSet(this.storeSoilNHumus)) {
      this.storeSoilNHumus = this.round(this.requafertiSoil.nhumus, 2)
    }
    if (!this.isParameterSet(this.storeSoilConversionFactor)) {
      this.storeSoilConversionFactor = this.round(this.requafertiSoil.fact_conv, 2)
    }
    if (!this.isParameterSet(this.storeSoilKm)) {
      this.storeSoilKm = this.round(this.requafertiSoil.km, 3)
    }
    if (!this.isParameterSet(this.storeSoilMineralizationPotential)) {
      this.storeSoilMineralizationPotential = this.round(this.requafertiSoil.pot_mineral, 2)
    }

    // Refresh online data (do not wait until completion)
    this.loadSoilProperties('network-only').then(() => this.loadSoilParams('network-only'))
  },
  methods: {
    onClickNext () {
      // clear unused organic measure fields
      for (const organicMeasureTypeOption of this.organicMeasureTypeOptions) {
        if (organicMeasureTypeOption.value !== this.storeSoilOrganicMeasureType?.value) {
          this[organicMeasureTypeOption.field] = null
        }
      }

      this.$router.replace({
        name: 'requafertiPreviousCropProfile'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiCropProfile'
      })
    },
    async loadSoilProperties (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: querySoilDerivedObjectsByPlotId,
        variables: {
          plot_id: this.plotId
        },
        fetchPolicy
      })
      this.plotSoilDerivedProperties = data?.soil_derived_object?.[0]?.derived_observations?.map(observation => ({
        id: observation.observed_property_id,
        value: observation.result.value || null
      })) || []
    },
    async loadSoilParams (fetchPolicy) {
      const soilParamVariables = {
        geometry: this.plotCenterGeometry
      }
      if (this.plotSoilDerivedProperties) {
        for (const plotSoilDerivedProperty of this.plotSoilDerivedProperties) {
          if (SOIL_DERIVED_PROPERTIES.includes(plotSoilDerivedProperty.id)) {
            soilParamVariables[plotSoilDerivedProperty.id] = Number(plotSoilDerivedProperty.value)
          }
        }
      }
      const { data } = await this.$apollo.query({
        query: queryRequafertiSoil,
        variables: soilParamVariables,
        fetchPolicy
      })
      this.requafertiSoil = data?.requaferti__soil
    },
    round (value, digits) {
      if (value === null || value === undefined || isNaN(value)) {
        return value
      } else {
        return Number(value.toFixed(digits))
      }
    }
  }
}
</script>
